C     Last change:  CWM   8 Nov 1999    8:23 am
      SUBROUTINE CULV2B(NPROG)
      INCLUDE 'INCLUDE.fi'
C THIS SUBROUTINE ASSUMES AN ARRESTED WEDGE.
      INTEGER*4 NPROG,NSTEP,NDA2,IQ1,IAS,IX,IDX
      REAL*8 EGL(40),XTRY( 40),QMAX,QMIN,H1N
      REAL*8 TRY,U1S
      REAL*8 EGLN,DA,DA2,DA1,DA1DX,Q1P,Q2P
      REAL*8 DADX,DX1,DX2,DXBAR,DA2DX,COEF
      REAL*8 FR1SQ,TAUT,TOTHEADS,RT,FT
      REAL*8 RW1,U1,RZ,FW1,FZ,TAUE1,TAUW1,TAUZ,DX
C     WRITE(6,35)
C  35 FORMAT(/' COMPUTATION FOR AN ARRESTED WEDGE --' / )
C      IF (PRINTIT) THEN
C        WRITE(17,*)' IN CULV2B'
C        WRITE(17,*)' TT1  ',TT1,' TT2   ',TT2   ,'  TT3  ',TT3,
C     A   ' TT4   ',TT4
C        WRITE(17,*)' TT7  ',TT7,' TT8   ',TT8   ,'  TT9  ',TT9,
C     A   ' HN    ',HN
C        WRITE(17,*)' HS   ',HS ,' RHO1  ',RHO1  ,'  RHO2 ',RHO2,
C     A   ' CNHW  ',CHNW
C         WRITE(17,*)' FL   ',FL ,' ENTRN1',ENTRN1,'  ENTRS',ENTRS
C         ENDIF
C      EGL=0.0D0
C      XTRY=0.0D0
      G = 32.2
      NSTEP = 25
      NDA2 = NSTEP
C QMAX IS BASED ON F1 = 1 AT NORTH END WITH MAXIMUM POSSIBLE A1N.
      A1N = HN*RHO2/RHO1
c  DGT found situations where SQRT below was negative number
      QMAX = CHNW*A1N*SQRT(EPS*G*A1N)
      QMIN = 0.
      DO IQ1 = 1,25   !QLOOP
        Q1 = 0.5*(QMAX + QMIN)
C FOR TRIAL Q1, F1 MUST BE UNITY AT NORTH END. A1N IS CALCULATED FROM
C THIS FACT. A2N IS THEN OBTAINED BY HYDROSTATICS.
        A1N = DMIN1(HEIGHT,(Q1*Q1/(CHNW*CHNW*EPS*G))**0.3333333)
        A2N = DMAX1(0.0D0,DMIN1(HN - RHO1*A1N/RHO2,HEIGHT-A1N))
        H1N=(HN-EPS*A2N)/(1.0D0 - EPS)
C FOR ARRESTED WEDGE, Q2 = 0.
      Q2 = 0.
C DETERMINE DEPTH (A1S) JUST INSIDE OF CULVERT ACCOUNTING FOR
C VELOCITY HEAD. A1SMIN IS BASED ON CRITICAL DEPTH.
        A1S = HS-(Q1*Q1/(CHNW*CHNW*G*HS*HS))
        A2S = 0.0D0
        DO IAS = 1,25
          TRY=A1S
          A1S = DMIN1(HEIGHT,HS - Q1*Q1/(CHNW*CHNW*2.*G*TRY*TRY))
          IF (ABS(A1S - TRY) .LE. 0.0001) GO TO 1010
        ENDDO
C     WRITE (6,1006) IAS
C1006 FORMAT ( ' IAS =', I5  )
        NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.1'
        RETURN
 1010   CONTINUE
        U1S = Q1/(A1S*CHNW)
C SENTR IS THE ENERGY SLOPE RESULTING FROM UNIFORM DISTRIBUTION
C OF THE ENTRANCE LOSS ALONG THE LENGTH OF THE CULVERT.
        SENTR1 = ENTRN1*U1S*U1S/(2.*G*FL)
        SENTR2 = 0.
C PERFORM INTEGRATION FROM NORTH TO SOUTH TO OBTAIN FLOW LENGTH TO
C MATCH HS. FROM NORTH END TO TOE OF WEDGE, INTEGRATION (DO 260 LOOP)
C MUST BE DONE AS A STRATIFIED FLOW COMPUTATION AS IN CULV1. UPSTREAM
C OF TOE, INTEGRATION (DO 1100 LOOP) IS AS IN CULV3 FOR SINGLE LAYER
C FLOW.
        A1 = A1N
        A2 = A2N
        X = 0.
        XTRY(1) = 0.
        TOTHEAD1=H1N
        TOTHEADS=HS - (Q1/(CHNW*A1S))**2/(2.0D0*G)
        IF(A2N.GT.0.0D0)THEN
          EGLN = TOTHEAD1+(Q1/(CHNW*A1N))**2/(2.0D0*G)
          EGL(1) = EGLN
          IX = 0
          IF(EGLN .GT. HS  )THEN
            QMAX = Q1
            GO TO 300 !CYCLE
          ENDIF
          DA = 0.
          DA2 = -A2N/NDA2
          DA1 = DA - DA2
          DO IX = 1,NDA2   !INTEGER LOOP
            A2BAR = A2 + 0.5*DA2
C FIND D  X FOR GIVEN DA2 BY TRIAL.
            DO IDX = 1,25
              A1BAR = A1 + 0.5*DA1
              DENOM = 1.0
C             F1SQ = Q1*Q1/(CHNW*CHNW*EPS*G*A1BAR**3)
C             FLHS = F1SQ
C              WRITE(*,*)F1SQ,'=F1SQ  ',F2SQ,'=F2SQ  ',FLHS,'=FLHS  CALL SLOPE'
              CALL SLOPE(DA1DX,DA2DX,DADX)
              DX1 = DA1/DA1DX
              DX2 = DA2/DA2DX
              DXBAR = 0.5*(DX1 + DX2)
              IF(TOTHEAD1.LT.HEIGHT)THEN
                DA = DADX*DXBAR
              ELSE
                DA = 0.0D0
              ENDIF
              DA1 = DA - DA2
              IF(ABS(DX1 - DX2) .LT. TOLDX)GO TO 230
            ENDDO
C     WRITE(6,226) IDX
C 226 FORMAT ( ' IDX =', I5  )
            NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.2'
            RETURN
  230       CONTINUE
            TOTHEAD1 = TOTHEAD1 + DADX*DX1
            IF(TOTHEAD1.GT.HEIGHT)THEN
              A2 = MAX(0.0D0,A2 + DA2)
              A1 = HEIGHT-A2
            ELSE
              A1 = A1 + DA1
              A2 = A2 + DA2
            ENDIF
            X = X + DXBAR
            XTRY(IX+1) = X
            EGL(IX+1) = TOTHEAD1 + Q1*Q1/(CHNW*CHNW*A1*A1*2.0*G)
C IF (EGL .LT. HS), THEN PROCEED WITH INTEGRATION. OTHERWISE, STOP
C AND INTERPOLATE TO FIND X CORRESPONDING TO EGL = HS.
            IF(EGL(IX+1) .LT.  HS  ) GO TO 240 !CYCLE integr
            COEF = (HS - EGL  (IX  ))/(EGL  (IX+1) - EGL  (IX  ))
            X = XTRY(IX  ) + COEF*(XTRY(IX+1) - XTRY(IX  ))
C IF EGL = HS BEFORE TOE OF WEDGE IS REACHED, THEN SKIP DO 1100 LOOP.
            GO TO 278
 240        CONTINUE
          ENDDO    !INTEGER LOOP
        ENDIF
C DETERMINE LENGTH FOR DEPTH TO CHANGE FROM A1  TO A1S.
        IF (TOTHEADS.GT.TOTHEAD1) THEN
          DA1 = (TOTHEADS - TOTHEAD1 )/NSTEP
          DO IAS =1,NSTEP
            A1BAR = DMIN1(HEIGHT,A1 + 0.5*DA1)
            U1 = Q1/(CHNW*A1BAR)
            FR1SQ = U1*U1/(G*A1BAR)
C ALLOCATE TOTAL RESISTANCE TO VARIOUS SHEAR SURFACES IN ORDER TO
C CONVERT FROM N TO F.
            A2BAR = 0.
            IF (TOTHEAD1+.5*DA1.GT.HEIGHT) THEN
              RW1=A1BAR*CHNW/(2*A1BAR+CHNW*(TT3+TT8))
              RZ=A1BAR*CHNW/(2.0D0/TT3+CHNW*(1.0D0+TT9))
              RT=A1BAR*CHNW/(2.0D0/TT8+CHNW*(1.0D0+1.0D0/TT9))
              FW1=116.7*NW1(ICHN)*NW1(ICHN)/RW1**0.333333
              FZ=116.7*NW1(ICHN)*NW1(ICHN)/RZ**0.333333
              FT=116.7*NW1(ICHN)*NW1(ICHN)/RT**0.333333
              TAUE1=G*RHO2*CHNW*A2BAR*SENTR1/(2.0D0*(CHNW + A1BAR))
              TAUW1 = FW1*RHO2*ABS(U1)*U1/8.
              TAUZ  = FZ*RHO2*ABS(U1)*U1/8.
              TAUT  = FT*RHO2*ABS(U1)*U1/8.
              DENOM=(TAUT+TAUZ+2.0D0*TAUE1+2.*A1BAR*(TAUW1+TAUE1)/CHNW)/
     +          (G*RHO1*A1BAR)
            ELSE
              RW1=CHNW*A1BAR/(2.*A1BAR+CHNW*TT1*TT4)
              RZ =CHNW*A1BAR/(2.*A1BAR/(TT1*TT4)+CHNW)
              FW1 = 116.7*NW1(ICHN)*NW1(ICHN)/RW1**0.333333
              FZ = 116.7*NZ(ICHN)*NZ(ICHN)/RZ**0.333333
              TAUE1 = G*RHO1*CHNW*A1BAR*SENTR1/(CHNW + 2.*A1BAR)
              TAUW1 =     FW1*RHO1*ABS(U1)*U1/8.
              TAUZ = FZ*RHO1*ABS(U1)*U1/8.
              DENOM=(TAUZ+TAUE1+2.*A1BAR*(TAUW1+TAUE1)/CHNW)/
     +          (G*RHO1*A1BAR)
            END IF
            DENOM = SZ - DENOM
            DX = (1.0 - FR1SQ)*DA1/DENOM
            X = X + DX
            IF(TOTHEAD1.GE.HEIGHT)THEN
              A1=HEIGHT
              TOTHEAD1=TOTHEAD1+DA1
            ELSE
              A1 = A1 + DA1
              TOTHEAD1=TOTHEAD1+DA1
            ENDIF
            A2 = 0.
          ENDDO
        ENDIF
  278   CONTINUE
C ADJUST Q1 BASED ON INTEGRATED LENGTH IN COMPARISON TO FL.
        IF(-X .LE. FL)THEN
          QMAX = Q1
        ELSE
          QMIN = Q1
        ENDIF
C IF INTEGRATED LENGTH AND DISCHARGE ARE WITHIN TOLERANCES, THEN
C STOP ITERATION.
        IF (ABS(FL + X) .LE. TOLX .AND.
     A    (QMAX-QMIN)      .LT. TOLQ1) GO TO 350
 300    CONTINUE
      ENDDO   !QLOOP
C     WRITE(6,310)  IQ1
C 310 FORMAT (  ' IQ1 =', I5  )
      NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.3'
      RETURN
  350 CONTINUE
C     WRITE(6,360) Q1, Q2
C  360 FORMAT(/     ' Q1 = ',F10.1,10X, 'Q2 = ',F10.1   /  /
C    1       11X, 'X', 13X, 'A', 12X, 'A1', 12X, 'A2',11X, 'LHS',12X,
C    2                  'F1', 12X, 'F2'     )
C     WRITE(6,390) XN,AN,A1N,A2N,FLHSN,F1N,F2 , IQ1,IX
C     IF(ITOE .EQ. 1)
C    AWRITE(6,390) XTOE,ATOE,A1TOE,A2TOE,FLHSTO,F1TOE,F2TOE
C     F1 = Q1/(CHNW*A1*SQRT(EPS*A1*G))
C     WRITE(6 , 390)  X, A, A1, A2 , FLHS, F1, F2
C 390 FORMAT (1X, F13.2, 3F14.3, 3F14.4, 2I10 )
C IF (A2 .GT. 0.), THEN ARRESTED WEDGE WILL NOT EXIST.
C A2 IS ASSUMED ZERO WITHIN THE TOLERANCE BELOW
      IF((A2.LT.0.1).OR.(CUL1.EQ.1))A2=0.0
      IF (A2 .GT. 0.) GO TO 500
C     WRITE(6,450)
C 450 FORMAT(/' WEDGE TOE IS IN CULVERT.'/' THEREFORE AN ARRESTED WEDGE
C    AIS THE CORRECT FLOW REGIME.' / )
      NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.4'
      RETURN
  500 CONTINUE
C     WRITE(6,525)
C 525 FORMAT(/' CALCULATED LOWER LAYER DEPTH AT SOUTH END IS GREATER THA
C    BN ZERO.' /' THEREFORE AN ARRESTED WEDGE WILL NOT EXIST.'/)
      NPROG = 1
      RETURN
      END


