C     Last change:  CWM  30 Nov 1999   12:33 pm
      SUBROUTINE CULV3(NPROG)
      INCLUDE 'INCLUDE.fi'
C THIS SUBROUTINE ASSUMES SINGLE LAYER FLOW.
      INTEGER*4 NPROG
      INTEGER*4 NSTEP,IAS,IQ1
      REAL*8 HDN,HDEP,DENSITY,ADN,QMAX,QMIN,QFLOW,DEP
      REAL*8 UVEL,FRN,TRY,UPSTRM,U1S,U1,FR1,F1,F1N
      REAL*8 DA1,XN,FR1N,FR1SQ,U1BAR,U2BAR,RW1,RZ,FW1
      REAL*8 FZ,TAUE1,TAUW1,TAUZ,DX,UVELUP,SENTRAN
      REAL*8 DNSTRM,PHEADUP,PHEADDN,FDENSITY,FRDN
      REAL*8 DDEP,PHEAD2,PHEADBAR,FRNSQ,RW,FW,TAUE
      REAL*8 TAUW,RT,FT,TAUT
      LOGICAL*1 SOUTONOR
C     WRITE(6,100)
C  100 FORMAT(/ ' COMPUTATION FOR SINGLE LAYER FLOW --'  /  )
C      IF (PRINTIT) THEN
C        WRITE(17,*)' IN CULV3'
C        WRITE(17,*)' TT1  ',TT1,' TT2   ',TT2   ,'  TT3  ',TT3,
C     A   ' TT4   ',TT4
C        WRITE(17,*)' TT7  ',TT7,' TT8   ',TT8   ,'  TT9  ',TT9,
C     A   ' HN    ',HN
C        WRITE(17,*)' HS   ',HS ,' RHO1  ',RHO1  ,'  RHO2 ',RHO2,
C     A   ' CNHW  ',CHNW
C        WRITE(17,*)' FL   ',FL ,' ENTRN1',ENTRN1,'  ENTRS',ENTRS
C      END IF
      CUL1 = 0
      NSTEP = 25
c  DGT found problems for a case when HN=HS=12.5 RHO1=2.255, RHO2=2.341
C  Height=21
      IF(HN*RHO2/RHO1.GT.HS)THEN
        HDN=HS*RHO1/RHO2+EPS*HEIGHT  ! DGT why is HEIGHT involved here.  The water is way below the top for the case I have
        IF(HN.GE.HEIGHT)THEN
          IF((HN-HEIGHT)*RHO2/RHO1.LT.(HS-HEIGHT))THEN
            NPROG=2
            RETURN
          ENDIF
        ELSE
          IF (HS.GT.HN) THEN
            NPROG=2
            RETURN
          END IF
        ENDIF
        SOUTONOR=.FALSE.
        HDEP=HN
        DENSITY=RHO2
C       A2S(ICHAN)=HN-HEIGHT*RHO1/RHO2+HEIGHT
      ELSE
        IF(HN.GE.HEIGHT)THEN
          IF((HN-HEIGHT)*RHO2/RHO1.GT.(HS-HEIGHT))THEN
            NPROG=2
            RETURN
          ENDIF
        ENDIF
        IF(HN*RHO2/RHO1 .GE. 0.99*HS)THEN
C         WRITE(6,150) A1N,HS
C 150     FORMAT(/' SINGLE LAYER FLOW CANNOT EXIST BECAUSE A1N .GE. HS'  /
C    A    ' A1N =', F7.2, '     HS =', F7.2/)
          NPROG = 2
          RETURN
        ENDIF
        SOUTONOR=.TRUE.
        HDN=HN*RHO2/RHO1
        HDEP=HS
        DENSITY=RHO1
C IF(A1N .GE. HS), THEN SINGLE LAYER FLOW IS NOT POSSIBLE.
      ENDIF
 200  CONTINUE
C MAX Q1 IS FOR VELOCITY HEAD AT SOUTH END = HS - A1N.
      IF (SOUTONOR) THEN
        ADN=HN*RHO2/RHO1
        HDN=HN*RHO2/RHO1
      ELSE
        ADN = MIN(HEIGHT,HS/(RHO2/RHO1-1.0D0))  
c  DGT is concerned as to  why there is a -1 in the above line. It does not seem to make
C   physical sense.  There should be North to South and South to North symmetry and there is not
        HDN=HS*RHO1/RHO2+EPS*ADN
      END IF
c  DGT found that the SQRT below can result in a negative number
      QMAX = MIN(HDEP,HEIGHT)*CHNW*SQRT(2.*G*(HDEP -HDN))
      QMIN = 0.0
      DO IQ1 = 1,25 !FLOWTRY LOOP
        QFLOW = 0.5*(QMAX + QMIN)
        DEP=HDEP*2.0D0/3.0D0
        UVEL = QFLOW/(CHNW*DEP)
        FRN = UVEL/SQRT(G*DEP)
        IF (FRN .GE. 1.0)THEN
          QMAX = QFLOW
          GO TO 1100  !CYCLE FLOWTRY LOOP
        ENDIF
C FOR TRIAL Q1, USE TRIAL AND ERROR TO
C DETERMINE DEPTH (A1S) JUST INSIDE OF CULVERT ACCOUNTING FOR
C VELOCITY HEAD.
C A1SMIN IS BASED ON CRITICAL CONDITION FOR ASSUMED Q1.
        DO IAS = 1,25
          TRY = DEP
          DEP = MIN(HEIGHT,HDEP-(QFLOW/(CHNW*DEP))**2/(2.0*G))
          IF (ABS(TRY - DEP) .LE. 0.00001)GO TO 1000 !EXIT
        ENDDO
 1000   CONTINUE
C     WRITE(6,1006) IAS
C1006 FORMAT (/' IAS =', I5   /  )
        UPSTRM = HDEP - (QFLOW/(CHNW*DEP))**2 / (2.0D0 *G)
C IF (A1S .LE. DNSTRM), THEN TRIAL Q1 IS TOO LARGE.
        IF (UPSTRM .LE. HDN)THEN
          QMAX = QFLOW
          GO TO 1100   !CYCLE flowtry
        ENDIF
C SENTR IS THE ENERGY SLOPE RESULTING FROM UNIFORM DISTRIBUTION OF THE
C ENTRANCE LOSS ALONG THE LENGTH OF THE CULVERT ASUMMING THAT LOSS
C COEFFICIENT FOR SOUTH END WITH SINGLE LAYER FLOW IS THE SAME AS
C THAT FOR LOWER LAYER AT NORTH END FOR TWO LAYER FLOW (I.E. ENTRS =
C ENTRN1).
        UVELUP = QFLOW/(DEP*CHNW)
        SENTRAN = ENTRN1*UVELUP*UVELUP/(2.*G*FL)
        UVEL = QFLOW/(CHNW*ADN)
        FRN = UVEL/SQRT(G*ADN)
        DNSTRM=ADN
C IF (FRN .GT. 1.) THEN REPLACE DNSTRM BY CRITICAL DEPTH.
        IF (FRN .GE. 1.0)THEN
          ADN = MIN(HEIGHT,(QFLOW*QFLOW/(CHNW*CHNW*G))**0.333333)
          IF (ADN.LT.HEIGHT) THEN
            HDN = ADN
          END IF
          UVEL = QFLOW/(CHNW*ADN)
          FRN = UVEL/SQRT(G*ADN)
        ENDIF
        PHEADUP=UPSTRM
        PHEADDN=HDN
        FDENSITY = FRN/SQRT(EPS)
        FRDN = FDENSITY
        DDEP = (PHEADUP - PHEADDN)/NSTEP
        PHEAD2=PHEADDN
        X = 0.
C PERFORM INTEGRATION WITH RESPECT TO X BEGINNING AT NORTH END.
        DO IAS =1,NSTEP
          PHEADBAR = PHEAD2 + 0.5*DDEP
          A2BAR = MIN(HEIGHT,PHEADBAR)
          UVEL = QFLOW/(CHNW*A2BAR)
          FRNSQ = UVEL*UVEL/(G*A2BAR)
C ALLOCATE TOTAL RESISTANCE TO VARIOUS SHEAR SURFACES IN ORDER TO
C CONVERT FROM N TO F.
          IF(PHEADBAR.LT.HEIGHT)THEN
           	RW=CHNW*A2BAR/(2.*A2BAR+CHNW*TT1*TT4)
           	RZ =CHNW*A2BAR/(2.*A2BAR/(TT1*TT4)+CHNW)
            FW = 116.7*NW1(ICHN)*NW1(ICHN)/RW**0.333333
            FZ = 116.7*NZ(ICHN)*NZ(ICHN)/RZ**0.333333
            TAUE = G*DENSITY*CHNW*A2BAR*SENTRAN/(CHNW + 2.*A2BAR)
            TAUW =     FW*DENSITY*ABS(UVEL)*UVEL/8.
            TAUZ = FZ*DENSITY*ABS(UVEL)*UVEL/8.
            DENOM=(TAUZ+TAUE+2.*A2BAR*(TAUW+TAUE)/CHNW)/
     -        (G*DENSITY*A2BAR)
          ELSE
            RW=A2BAR*CHNW/(2*A2BAR+CHNW*(TT3+TT8))
            RZ=A2BAR*CHNW/(2.0D0/TT3+CHNW*(1.0D0+TT9))
            RT=A2BAR*CHNW/(2.0D0/TT8+CHNW*(1.0D0+1.0D0/TT9))
            FW=116.7*NW1(ICHN)*NW1(ICHN)/RW**0.333333
            FZ=116.7*NW1(ICHN)*NW1(ICHN)/RZ**0.333333
            FT=116.7*NW1(ICHN)*NW1(ICHN)/RT**0.333333
            TAUE=G*RHO2*CHNW*A2BAR*SENTRAN/(2.0D0*(CHNW + A2BAR))
            TAUW = FW*RHO2*ABS(UVEL)*UVEL/8.
            TAUZ  = FZ*RHO2*ABS(UVEL)*UVEL/8.
            TAUT  = FT*RHO2*ABS(UVEL)*UVEL/8.
            DENOM=(TAUT+TAUZ+2.0D0*TAUE+2.*A2BAR*(TAUW+TAUE)/CHNW)/
     +      	(G*RHO2*A2BAR)
          ENDIF
          DENOM = SZ - DENOM
          DX = (1.0 - FRNSQ)*DDEP/DENOM
          X = X + DX
          PHEAD2 = PHEAD2 + DDEP
        ENDDO
C IF INTEGRATED LENGTH AND DISCHARGE HAVE BEEN BRACKETED TO WITHIN
C TOLERANCES, THEN STOP THE ITERATION ON QFLOW.
        IF (ABS(FL + X) .LE. TOLX .AND.
     A     (QMAX-QMIN)      .LT. TOLQ1) GO TO 1200
C COMPARE INTEGRATED FLOW LENGTH WITH CULVERT LENGTH AND ADJUST
C DISCHARGE ACCORDINGLY.
        IF(ABS(-X+FL).LE.1.0D-14) GO TO 1200
        IF (X .LT. -FL) QMIN = QFLOW
        IF (X .GT. -FL)  QMAX = QFLOW
 1100   CONTINUE
      ENDDO !flowtry LOOP
C     WRITE(6,1151) IQ1
C1151 FORMAT(/' IQ1 =', I5/)
      NPROG = 3
*      WRITE(*,*)'SINGLE LAYER FLOW: CULV3.1'
      IF (SOUTONOR) THEN
        A1S=UPSTRM
        A2S=0.0D0
        A1N=DNSTRM
        A2N=0.0D0
        Q1=QFLOW
        Q2=0.0D0
      ELSE
        A1S=0.0D0
        A2S=DNSTRM
        A1N=0.0D0
        A2N=UPSTRM
        Q2=QFLOW
        Q1=0.0D0
      END IF
      RETURN
 1200 CONTINUE
      UVEL = QFLOW/(CHNW*DEP)
      FRN = UVEL/SQRT(G*DEP)
      FDENSITY = FRN/SQRT(EPS)
C     WRITE(6,1220) Q1
C1220 FORMAT(/' Q1 =',F10.1 / )
C     WRITE(6,1225) XN,A1N,F1N,FR1N,X,A1,F1,FR1
C1225 FORMAT( ' X =',F8.2,5X,'A1 =',F8.3,5X,'F1 =',F7.3,5X,'FR1 =',
C    A F7.3  )
      IF(FRDN .GE. 1.) GO TO 1300
C     WRITE(6,1275)
C1275 FORMAT(/' DENSIMETRIC FROUDE NUMBER AT NORTH END IS LESS THAN UNIT
C    AY.' / ' THEREFORE SINGLE LAYER FLOW WILL NOT EXIST.'  / )
      NPROG = 2
      RETURN
 1300 CONTINUE
C     WRITE(6,1350)
C1350 FORMAT(/' DENSIMETRIC FROUDE NUMBER AT NORTH END IS GREATER THAN U
C    ANITY.' /' THEREFORE SINGLE LAYER FLOW IS THE CORRECT FLOW REGIME.'
C    B  /  )
      NPROG = 3
*      WRITE(*,*)'SINGLE LAYER FLOW: CULV3.2'
      IF (SOUTONOR) THEN
        A1S=UPSTRM
        A2S=0.0D0
        A1N=DNSTRM
        A2N=0.0D0
        Q1=QFLOW
        Q2=0.0D0
      ELSE
        A1S=0.0D0
        A2S=DNSTRM
        A1N=0.0D0
        A2N=UPSTRM
        Q2=QFLOW
        Q1=0.0D0
      END IF
      RETURN
      END !SUBROUTINE




