      
      PROGRAM MODEL
      
C    Model changed by INM 07/08/2011
C    The model handles data with any length since modification has been made to include dynamic arrays
C    1)  PERIOD OF CALIBRATION IS 1/87 TO 12/98
C    2)  THIS IS THE CALIBRATED VERSION OF THE MODEL
C    3)  BREACH FLOW AND EVAPORATION ARE COMPUTED, 
C		USES MEASURED/ESTIMATED CULVERT FLOW VALUES 


C**************************  DECLARE VARIABLES  *********************
	INCLUDE 'INCLUDE.fi'
      LOGICAL*1 LCULV
      REAL*8 CLNPPT,AS,AN,VS,VN,PS,PN,DP,TEMX,PFT,CS, VT, LT
      REAL*8 CN,HAVG,Q1F,Y2F,Q2F,QS,QN,SCFS,SCFN,FCN,LMAX,vntemp,VDIF
      REAL*8 LESnew,LENnew,QSMSUM,QNMSUM, VDIFsum
      real*8 PSVol,PNVol,QGSvol,QGNvol,WSVol,WNVol,ESVol,ENVol
      real*8 LES1,LEN1,LS1,LN1,CLNPPT1,AN1,AS1,VN1,VS1,VT1,CT,LT1
      real*8 vsnew,asnew,vnnew,annew
      INTEGER*4 NCHAN,J,IN,JJ,JJJ,K,NPROG,TSCC,ISD
      character*20 filehead
      DATA (NW1(I),NW2(I),NI(I),NZ(I),NT(I),I=1,2)/.015,.015,.01,
     -    .024,.015 ,.015,.015,.01,.015,.015/
 
C**************************  TEMPORARY OPEN FILES TO GET DIMENSIONS  ****************************

      OPEN (UNIT=13,FILE='BATHYMETRY.txt',STATUS='OLD',ERR=1000)
      read(13,*)nbs,nbn  ! Read number of north and south bathymetries
      read(13,'(A)') filehead
      NBATH=0  ! for header
  1   READ(13,*,END=2) DUMMY
      NBATH=NBATH+1
      GO TO 1
  2   CONTINUE
      IF(NBATH.EQ.0) go to 1000
      CLOSE(13)

      OPEN (UNIT=14,FILE='MonthlyInputs_TR_E85.txt',STATUS='OLD',
     - ERR=1000)
      read(14,'(A)') filehead
      NDAT=0
  3   READ(14,*,END=4) DUMMY2
      NDAT=NDAT+1
      GO TO 3
  4   CONTINUE
      IF(NDAT.EQ.0) go to 1000
      CLOSE (14)
      
      
C**************************  OPEN FILES  ****************************
      
      OPEN (UNIT=13,FILE='BATHYMETRY.txt',STATUS='OLD')
      OPEN (UNIT=14,FILE='MonthlyInputs_TR_E85.txt',STATUS='OLD')
      OPEN (UNIT=15,FILE='matrix.txt',STATUS='OLD',ERR=1000)
      OPEN (UNIT=16,FILE='outputfile.txt',STATUS='UNKNOWN')
      OPEN (UNIT=17,FILE='longoutput.txt',STATUS='UNKNOWN')
c      OPEN (UNIT=18,FILE='test.txt',STATUS='UNKNOWN')

C  START READING AND WRITING IN THE OPENED FILES, AT TOP OF EACH FILE 

C DGT commented these out.  They are redundant with opens immediately above      
!      REWIND (UNIT=13)
!      REWIND (UNIT=14)
!      REWIND (UNIT=15)
!      REWIND (UNIT=16)
!      REWIND (UNIT=17)
!      REWIND (UNIT=18)
      
C ***********************  SET INITIAL CONDITIONS  ********************
C  DGT Changes to read initial conditions
      OPEN (UNIT=20,FILE='InitialConditionsTR.txt',STATUS='OLD')
      read(20,*)LS
      read(20,*)LN
      read(20,*)CLNPPT
      read(20,*)LES
      read(20,*)LEN
      read(20,*)KLS
      read(20,*)KLN
      read(20,*)ClLS
      read(20,*)ClLN
      read(20,*)MgLS
      read(20,*)MgLN
      read(20,*)NaLS
      read(20,*)NaLN
      read(20,*)LMAX
      Close(20)
      
C  WATER AND SALT BALANCE CONSTANTS/INITIAL CONDITIONS
c      LS=2.08e9  ! DGT Read in
c      LN=3e9    ! DGT Read in
c      CLNPPT=0e9   ! DGT Read in
c      LNPPT=0.  ! DGT is initialized below and is an intermediate value
c      RESOLN=0.
c      LES=210.97  ! DGT Read in
c      LEN=210.37   ! DGT Read in
      HD=LES-LEN
      IF(HD.LE.0.08)HD=0.08
      DAY=1
      QSMSUM=0
      QNMSUM=0
      VDIFsum=0
      PSvol=0
      PNvol=0
      ESvol=0
      ENvol=0
!      AS=995478  ! DGT evaluated below after bathymetry tables read in 
!      AN=519964  
!      VS=18852158
!      VN=10383004
!      PS=1.051
!      PN=1.131
!      DP=PN-PS
!      KLS=39000000  ! DGT Read in
!      KLN=51000000
!      ClLS=1087000000
!      ClLN=1348000000
!      MgLS=70000000
!      MgLN=70000000
!      NaLS=610000000
!      NaLN=771000000
      

C  CHANNEL FLOW CONSTANTS/INITIAL CONDITIONS
      NCHAN=2   !  DGT changed to 2 
!      CHANT(1)=214.0
!      CHANT(2)=203.0
!      CHANB(1)=200.0
!      CHANB2(1)=198.0
!      CHANB(2)=182.0
!      CHANW(1)=290.0
!      CHANW(2)=30.0
!      BSLOPE=9.0
!      EBBR=210.0
      SZ=0.0
      TOLX=3.0
      TOLDX=0.01
      TOLQ1=15.0
      TOLHS=0.02
      DELA1=0.2
      ENTRS=0.5
      ENTRN1=0.85
      ENTRN2=0.0
      FCOEF=1.0
      G=32.2
c      TSBD=1840  DGT now part of inputs
      DO I=1,NCHAN
        NI(I) = NI(I)*SQRT(FCOEF)
        TT(1,I) = (NI(I)/NW1(I))**1.5
        TT(2,I) = (NI(I)/NW2(I))**1.5
        TT(3,I) = (NZ(I)/NW2(I))**1.5
        TT(4,I) = (NZ(I)/NI(I))**1.5
        TT(7,I) = (NT(I)/NI(I))**1.5
        TT(8,I) = (NT(I)/NW1(I))**1.5
        TT(9,I) = (NT(I)/NZ(I))**1.5
      END DO

C  FILL FLOW CONSTANTS/INITIAL CONDITIONS
      FBEI=200.0
      FEEI=200.0
      FBBE=175.
      FEBE=175.
      FBNP=1.
      FENP=1.
      FBOP=.1
      FEOP=.1

C**********************  READ INPUT FILE  ********************
      N=NDAT
      NTS=N*TSPM
      
    
      ALLOCATE (AQINA(N),AQINB(N),AQIN(N),AQISA(N),AQISB(N),AQISC(N),
     -  AQIS(N),AQEN(N),AQES(N),AXES(N),AXEN(N),AQWP(N),ALWP(N),AMBS(N),
     -  AMBN(N),AMECS(N),AMECN(N),AMWCS(N),ANaLWP(N),AMgLWP(N),AKLWP(N),
     -  AClLWP(N),AMWCN(N),QIN(0:NTS),QIS(0:NTS),QES(0:NTS),QEN(0:NTS),
     -  QWP(0:NTS),LWP(0:NTS),NaLWP(0:NTS),MgLWP(0:NTS),KLWP(0:NTS),
     -  MBS(0:NTS),MBN(0:NTS),MECS(0:NTS),MECN(0:NTS),ClLWP(0:NTS),
     -  MWCS(0:NTS),MWCN(0:NTS),XES(0:NTS),XEN(0:NTS),
     -  SOUTH(3,NBATH,nbs),NORTH(3,NBATH,nbs),YEARIN(N),
     -  MONTHIN(N),CHANTV(2,N),CHANBV(2,N),CHANWV(2,N),USEMC(N),
     -  PONDWS(N),PONDWN(N),SBATHSEL(N),NBATHSEL(N),
     -  PRFS(N),PRFN(N),LRETS(N),LRETN(N),FOPIN(N),
     -  BSLOPEV(2,N),EBBRV(2,N))    
     
C  READ IN THE SOUTH AND NORTH PART ELEV/AREA/VOL TABLES
C  SOUTHA IS SOUTH ARM WITH MAGCORP POND TABLE
C  SOUTHB IS SOUTH ARM ONLY TABLE
C  NORTH  IS NORTH ARM ONLY TABLE  
      read(13,*)nbs,nbn
      read(13,'(A)') filehead   ! read header   
      DO 5 J=1,NBATH
      READ (13,*) SOUTH(1,J,1),
     - (SOUTH(2,J,I),SOUTH(3,J,I),I=1,nbs),
     -  (NORTH(2,J,I),NORTH(3,J,I),I=1,nbn)
   5  CONTINUE 
c   6  FORMAT (7F10.0)  DGT free format read being used
      CLOSE(13)
      do I = 1,nbs
      SOUTH(1,1:NBATH,i)= SOUTH(1,1:NBATH,1)
      enddo
      do i=1,nbn
      NORTH(1,1:NBATH,i) = SOUTH(1,1:NBATH,1)   
      enddo  
      
C  READ IN THE SOUTH AND NORTH PART EVAP AND INFLOW DATA FROM EVAP INPUT FILE 
C  READ IN THE WEST POND PUMPING WATER AND SALT IN/OUTFLOW DATA
C  READ IN THE WEST POND PUMPING ION IN/OUTFLOW DATA    
      read(14,'(A)') filehead   ! read header  
      DO 7 IN=1,N
C JSW ADDED ADDITIONAL CHANNELS AND BSLOPE&EBBR
      READ(14,*) YEARIN(IN),MONTHIN(IN),AXES(IN),
     - AXEN(IN),AQISA(IN),AQISB(IN),AQISC(IN),AQINA(IN),AQINB(IN),
     - AQWP(IN),ALWP(IN),ANaLWP(IN),AMgLWP(IN),AKLWP(IN),AClLWP(IN),
     - PONDWS(IN),PONDWN(IN),PRFS(IN),PRFN(IN),LRETS(IN),LRETN(IN),
     - CHANTV(1,IN),CHANBV(1,IN),CHANWV(1,IN),CHANTV(2,IN),CHANBV(2,IN),
     - CHANWV(2,IN),SBATHSEL(IN),NBATHSEL(IN),FOPIN(IN),
     - !(CHANTV(i,IN),(CHANBV(i,IN),CHANWV(i,IN),i=3,NCHAN),!UNCOMENT OUT IF NCHAN>2
     - (EBBRV(i,IN),BSLOPEV(i,IN),i=1,NCHAN)
!        READ(14,*) YEARIN(IN),MONTHIN(IN),AQES(IN),AQEN(IN),AXES(IN),
!     - AXEN(IN),AQIS(IN),AQIN(IN),AQWP(IN),ALWP(IN),ANaLWP(IN),
!     - AMgLWP(IN),AKLWP(IN),AClLWP(IN)
   7  CONTINUE
c  10  FORMAT(I4,1X,I2,1X,2(F11.2,1X),2(F11.6,1X),2(F11.2,1X),f7.0,1X,
c     -       f7.3,1X,4(f7.3,1X))   DGT free format read being used
      CLOSE(14)
c      AQIS(1:N)=AQISA(1:N)+AQISB(1:N)+AQISC(1:N)
c      AQIN(1:N)=AQINA(1:N)+AQINB(1:N)
      YEAR = YEARIN(1)
      MONTH = MONTHIN(1)
!C  READ IN THE WEST POND PUMPING WATER AND SALT IN/OUTFLOW DATA
!      READ(15,30) (AQWP(IN),ALWP(IN),IN=1,N)
!   30 FORMAT(f7.0,1x,f7.3) 
!
!C  READ IN THE WEST POND PUMPING ION IN/OUTFLOW DATA
!      READ(15,35) (ANaLWP(IN),AMgLWP(IN),AKLWP(IN),AClLWP(IN),
!     -  IN=1,N)
!   35 FORMAT(4f7.3)

C  READ IN THE MEASURED/ESTIMATED BREACH AND CULVERT FLOWS
c   DGT commented out the below so that the model calculates the breach and culvert flows
c        READ(15,40) (AMBS(IN),AMBN(IN),AMECS(IN),AMECN(IN),
c     -  AMWCS(IN),AMWCN(IN),IN=1,N)
c   40 FORMAT(6f8.0)
   
C  THIS SECTION TAKES VARIABLES WITH ONE VALUE PER MONTH AND GIVES 
C    THEM A VALUE FOR EACH TIME STEP
C  DGT altered this time model a little bit. 0 values were never used because the main (200)
c  loop was from 1 to NTS.
c  time convention now is
c   month indices  J  1 1 ... 1  2   2 ...  2   3 ...    N
c   step indices   K  1 2 .. 16  17 18  .. 32  33 ...   NTS = N*(TSMP=16)
      DO 60 J=1,N
c       JJ=J*TSPM-1
        JJ=J*TSPM  ! DGT change
        JJJ=JJ+1-TSPM
c        IF(J.EQ.N)JJ=JJ+1   ! DGT not needed with changes
        DO 50 K=JJJ,JJ
c          QES(K)=AQES(J)*TS  ! DGT not using
c          QEN(K)=AQEN(J)*TS
c    DGT changed below for inputs in depth per month and for precisely TSPM=16 time steps per month
          XES(K)= AXES(J)/float(TSPM) ! AXES(J)*TS
          XEN(K)= AXEN(J)/float(TSPM) ! AXEN(J)*TS
c          QIS(K)=AQIS(J)*TS
c          QIN(K)=AQIN(J)*TS
          QWP(K)=AQWP(J)/float(TSPM)
          LWP(K)=ALWP(J)*1e9/float(TSPM)
          ClLWP(K)=AClLWP(J)*1e6/float(TSPM) 
          KLWP(K)=AKLWP(J)*1e6/float(TSPM)
          NaLWP(K)=ANaLWP(J)*1e6/float(TSPM)
          MgLWP(K)=AMgLWP(J)*1e6/float(TSPM)
c          MBS(K)=AMBS(J)  ! DGT not using measured flows
c          MBN(K)=AMBN(J)
c          MECS(K)=AMECS(J)
c          MECN(K)=AMECN(J)
c          MWCS(K)=AMWCS(J)
c          MWCN(K)=AMWCN(J)
   50   CONTINUE
   60 CONTINUE

C  READ IN THE FILL FLOW MATRIX
      READ(15,*)MATRIX
   70 FORMAT(F9.3,17F9.2)
   
c   DGT - Now calculate volumes and area initial conditions   
c      IF(USEMC(1) .eq. 1)THEN
       CALL LEV2AV(LES,AS,VS,SOUTH(1,1,SBATHSEL(1)),NBATH)  ! Returns AS, VS given LES c      ELSE
c         CALL LEV2AV(LES,AS,VS,SOUTH(1,1,2),NBATH) 
c      ENDIF
      Call LEV2AV(LEN,AN,VN,NORTH(1,1,NBATHSEL(1)),NBATH)
!      AS=995478  
!      AN=519964
!      VS=18852158
!      VN=10383004
!      PS=1.051
!      PN=1.131
!      DP=PN-PS  
      VT=VS+VN
      PS=1.000+0.63*(LS*.0007353)/VS
      PN=1.000+0.63*(LN*.0007353)/VN
c   DGT My understanding is that the following line is a density temperature correction 
c   There are 192 time steps per year
c   192*0.032725 = 2 pi
c   In the original model I was 1 on Jan 1
c   For variable start time need to add a variable for the start day - call this ISD
      ISD=(MONTH-1)*TSPM   ! DGT       
      TEMX=12.5+12.0*SIN(.032725*(I+ISD)-1.958)
      PFT= (8*TEMX-(TEMX)**2+132416.)/132432.
      PS=PS*PFT/PF20
      PN=PN*PFT/PF20*.996
      DP=PN-PS
c   Record initial conditions for monthly outputs (beginning of interval values reported with 
c    each time step)     
        LES1=LES
        LEN1=LEN
        LS1=LS
        LN1=LN
        CLNPPT1=CLNPPT
        AN1=AN
        AS1=AS
        VN1=VN
        VS1=VS
        VT1=VT
        
   
C  WRITE INITIAL CONDITIONS TO OUTPUT FILES
c      WRITE(*,77)	
      WRITE(16,75)
	WRITE(17,77)
   75 FORMAT(' TSTEP DATE    LES      LEN
     -     LS9     LN9  LNPPT9 
     -    VDIF
     -    CSgperL  CNgperL QS QN PSVol PNVol QGSvol QGNvol WSVol 
     - WNVol ESVol ENVol AN AS VN VS')

!   75	FORMAT(' TSTEP DATE    HD      LES      LEN
!     -     DP     PS     PN     LS9     LN9  LNPPT9 
!     -  QSC1   QNC1   QSC2   QNC2       FS       FN 
!     -  QES   QEN     KLS     KLN
!     -    ClLS    ClLN    MgLS    MgLN    NaLS    NaLN  VDIF
!     -    CSgperL  CNgperL QS QN PSVol PNVol QGSvol QGNvol WSVol 
!     - WNVol ESVol ENVol AN AS VN VS')
      
   77	FORMAT(' TSTEP FalseDate    HD      LES      LEN
     -     DP     PS     PN     LS9     LN9  LNPPT9 
     -  QSC1   QNC1   QSC2   QNC2       FS       FN 
     -  QES   QEN     KLS     KLN
     -    ClLS    ClLN    MgLS    MgLN    NaLS    NaLN  VDIF
     -    CSgperL  CNgperL QSback QNback')
c   77	FORMAT(' TSTEP  MO/DAY/YR     HD      LES      LEN
c     -     DP     PS     PN     LS9     LN9  LNPPT9 
c     - QSC(1)  QNC(1)  QSC(2)  QNC(2)      FS      FN') 
c      WRITE(*,80)0,MONTH,DAY,YEAR,HD,4000.+LES,4000.+LEN,
c     -    PN-PS,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9
c      WRITE(17,80)0,MONTH,DAY,YEAR,HD,4000.+LES,4000.+LEN,
c     -    PN-PS,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9
c   80 FORMAT(I6,1x,2(I2,'/'),I4,F7.2,2F9.2,3F7.3,3F8.4,
c     -  6(1x,F7.0),F10.0)

C**************  BEGIN TIME INTERVAL LOOP (MAIN LOOP)  ************

      DO 200 I=1,NTS
      IN=(I-1)/TSPM+1  !  DGT This determines the month index for this particular time step
      MONTH=MONTHIN(IN)  ! DGT from input file.
      YEAR=YEARIN(IN)  ! DGT from input file.

C  CALCULATE NEW DENSITIES (PS,PN AND DP)
      PS=1.000+0.63*(LS*.0007353)/VS
      PN=1.000+0.63*(LN*.0007353)/VN
      TEMX=12.5+12.0*SIN(.032725*(I+ISD)-1.958)
      PFT= (8*TEMX-(TEMX)**2+132416.)/132432.
      PS=PS*PFT/PF20
      PN=PN*PFT/PF20*.996
      DP=PN-PS
      CS=((PS-1.0)/0.63)*100.  
      CN=((PN-1.0)/0.63)*100.
      KCS=KLS/VS
      KCN=KLN/VN
      ClCS=ClLS/VS
      ClCN=ClLN/VN
      MgCS=MgLS/VS
      MgCN=MgLN/VN
      NaCS=NaLS/VS
      NaCN=NaLN/VN

C  FOR FILL FLOW CALIBRATION RUNS, SKIP TO 130
C      GOTO 130

C  BREACH AND CULVERT FLOW COMPUTATIONS BEGIN HERE; 
C    ICHN=1 FOR THE BREACH, 2 FOR THE TWO CULVERTS COMBINED

C  DEEPEN THE BREACH BOTTOM TO CHANB2(1) AT THE TIMESTEP WHERE 
C    THE BREACH WAS DEEPENED 
C  DGT This not needed as it is specified in input file
c      IF(I.GT.TSBD)then
c        CHANB(1)=CHANB2(1)
c      endif

C  BEGIN CHANNEL (BREACH/CULVERT) FLOW CALCULATION LOOP
      DO 130 ICHN=1,NCHAN
C  Assign parameters from inputs      JSW ADDED BLSOPE (ICHN) and EBBR (INCHN)
      CHANT(ICHN)=CHANTV(ICHN,IN)
      CHANB(ICHN)=CHANBV(ICHN,IN)
      CHANW(ICHN)=CHANWV(ICHN,IN)
      TT1=TT(1,ICHN)
      TT2=TT(2,ICHN)
      TT3=TT(3,ICHN)
      TT4=TT(4,ICHN)
      TT7=TT(7,ICHN)
      TT8=TT(8,ICHN)
      TT9=TT(9,ICHN)
      BSLOPE(ICHN)=BSLOPEV(ICHN,IN)
      EBBR(ICHN)=EBBRV(ICHN,IN)

C  SET THE CHANNEL WIDTH FOR THE SUB CALCULATIONS TO THE ACTUAL
C    BREACH BOTTOM WITH SO THAT BOTTOM FRICTION IS PROPERLY CALD'D - JSW CHANGED TO USE (ICHN) TO USE ANY SHAPE OPPENING
      IF(CHANB(ICHN).LT.EBBR(ICHN))THEN
         WBB=CHANW(ICHN)-BSLOPE(ICHN)*(EBBR(ICHN)-CHANB(ICHN))
      ELSE 
         WBB=CHANW(ICHN)
      ENDIF
      CHNW=WBB

  100 CONTINUE
c   DGT changed lines below to use ICHN subscript
c      HS=LES-CHANB(1)
	HS=LES-CHANB(ichn)
c      HN=LEN-CHANB(1)
	HN=LEN-CHANB(ichn)   
  
C  ASSUME CHANNEL FLOW IS ZERO IF LES ABOVE OR BELOW CHANNEL
C  JSW - Comment out script below to calculate submerged flow, otherwise will skip culver subroutines

      
       IF((LES.GE.CHANT(ICHN)).OR.
     -  (LES.LE.CHANB(ICHN)))THEN
          QSC(ICHN)=0.0
          QNC(ICHN)=0.0
          GOTO 130
      ENDIF

C  ASSUME WEIR FLOW: LEN <= CHANB AND CHANB < LES < CHANT
      IF((LEN.LE.CHANB(ICHN)).AND.
     -  (LES.LT.CHANT(ICHN)).AND.
     -  (LES.GT.CHANB(ICHN)))THEN
         QSC(ICHN)=3.5*CHNW*(LES-CHANB(ICHN))**1.5
         QNC(ICHN)=0.0
         GOTO 125
      ENDIF
     


C  CONVERT DENSITIES TO ENGLISH UNITS & REDUCE DENS. JUST N. OF CHANNEL
      HEIGHT=CHANT(ICHN)-CHANB(ICHN)
      RHO2=1.94*PN*(1.0-3.0E-06*QSC(ICHN))
      RHO1=1.94*PS
      EPS=(RHO2 - RHO1)/RHO2

C  CALCULATE AVERAGE CHANNEL LENGTH BASED ON AVERAGE DEPTH.
C    FL IS BASED ON THE AVERAGE LENGTH FOR A CULVERT WITH A RECTANGULAR
C    LONGITUDINAL CROSS SECTION 136 FT LONG UP TO A DEPTH OF 12 FT AND
C    THEN A TRAPEZOIDAL LONGITUDINAL CROSS SECTION WITH A BASE 88 FT 
C    LONG AND END SLOPES OF ONE.
      FL = 136.
      HAVG = 0.5*(HS+HN)
      IF(HAVG .GT. 12.) FL=136.*12./HAVG+(88.-(HAVG-12.))*(HAVG-12.)
     -  /HAVG

C  CALL SUBROUTINE FOR SINGLE LAYER FLOW COMPUTATION. IF NPROG RETURNS
C    EQUAL TO 3, THEN SINGLE LAYER FLOW WAS CORRECT AND PROGRAM IS READY
C    FOR NEXT CONDITION. OTHERWISE, PROCEED TO COMPUTATION FOR ARRESTED
C    WEDGE FLOW.
            LCULV=.TRUE.
            CALL CULV3(NPROG)
            IF(NPROG .EQ.3) GO TO 120
  110       CONTINUE
            IF(HN*RHO2/RHO1.GT.HS)THEN
              CALL CULV2A(NPROG)
            ELSE
              CALL CULV2B(NPROG)
            ENDIF

C IF NPROG RETURNS EQUAL TO 2, THEN ARRESTED WEDGE WAS THE CORRECT
C FLOWTYPE AND PROGRAM IS READY FOR NEW CONDITION. OTHERWISE, PROCEED
C TO COMPUTATION FOR TWO LAYER FLOW.
            IF(NPROG .EQ. 2.OR..NOT.LCULV) GO TO 120
            CALL CULV1(NPROG)
            LCULV=.FALSE.
            IF(NPROG .EQ. 2)GO TO 110

  120 CONTINUE  !PROGRAM IS READY FOR NEW A CONDITION

c     DGT In case there was a NaN set flow to 0, warn and keep going
      if(isnan(Q1))then
        write(6,*)year,month,day,' Q1 NaN set to 0'
        Q1=0
      endif
      if(isnan(Q2))then
        write(6,*)year,month,day,' Q2 NaN set to 0'
        Q2=0
      endif

      Q1PREV=Q1
      Q2PREV=Q2
      IF(Q2.LT.0.0)Q2=-Q2
      QSC(ICHN)=Q1
      QNC(ICHN)=Q2

  125 CONTINUE 

!      IF(ICHN.NE.1) GOTO 130
      
C  BEGIN BREACH FLOW TRAPEZOIDAL AREA COMPUTATIONS       - JSW CHANGED TO USE ICHN SCRIPT
      ETUL=((A1S+A1N)/2)+CHANB(ICHN)
      ETLL=((A2S+A2N)/2)+CHANB(ICHN)
      IF(CHANB(1).GE.ETLL)ETLL=CHANB(ICHN)
      SAUL=(ETUL-ETLL)*WBB
      SALL=(ETLL-CHANB(ICHN))*WBB
      
C  COMPUTE AREA OF THE BREACH UPPER FLOW LAYER
      IF(ETUL.GT.EBBR(ICHN))THEN
         IF(ETLL.GE.EBBR(ICHN))THEN
            AUBL=(ETUL-ETLL)*CHANW(ICHN)
         ELSE
            AUBL=(ETUL-EBBR(ICHN))*CHANW(ICHN)+(EBBR(ICHN)-ETLL)
     -       *(CHANW(ICHN)-BSLOPE(ICHN)*(EBBR(ICHN)-
     -       (EBBR(ICHN)+ETLL)/2))
         ENDIF
      ELSE
         AUBL=(ETUL-ETLL)*(CHANW(ICHN)-BSLOPE(ICHN)*(EBBR(ICHN)
     -    -(ETUL+ETLL)/2))
      ENDIF

C  COMPUTE AREA OF THE BREACH LOWER FLOW LAYER
      IF(ETLL.GT.EBBR(ICHN))THEN
         IF(CHANB(ICHN).GE.EBBR(ICHN))THEN
            ALBL=(ETLL-CHANB(ICHN))*CHANW(ICHN)
         ELSE
            ALBL=(ETLL-EBBR(ICHN))*CHANW(ICHN)+(EBBR(ICHN)-CHANB(ICHN))
     -       *(CHANW(ICHN)-BSLOPE(ICHN)*(EBBR(ICHN)-(EBBR(ICHN)
     -       +CHANB(ICHN))/2))
         ENDIF
      ELSE
         ALBL=(ETLL-CHANB(ICHN))*(CHANW(ICHN)-BSLOPE(ICHN)
     -    *(EBBR(ICHN)-(ETLL+CHANB(ICHN))/2))
      ENDIF

C  COMPUTE THE AREA CORRECTION FACTORS THAT WILL CONVERT THE 
C    DISCHARGES COMPUTED IN THE SUBS (RECTANGULAR AREAS) TO THE
C    ACTUAL AREAS AT THE BREACH (TRAPEZOIDAL AND RECTANGULAR)
      ULACF=0
      LLACF=0
      IF(SAUL.GT.0)ULACF=AUBL/SAUL
      IF(SALL.GT.0)LLACF=ALBL/SALL
 
C  ADJUST BREACH FLOWS FOR CORRECT CROSS-SECTIONAL AREAS
      IF(ICHN.EQ.1)QSC(ICHN)=QSC(ICHN)*ULACF
      IF(ICHN.EQ.1)QNC(ICHN)=QNC(ICHN)*LLACF

C  END BREACH FLOW TRAPEZOIDAL AREA COMPUTATIONS

  130 CONTINUE

C  SET ALL CHANNEL DISCHARGES TO ZERO IF NCHAN = 0
      IF(NCHAN.EQ.0)THEN
        DO 140 ICHN=1,MCHAN
          QSC(ICHN)=0.0
          QNC(ICHN)=0.0
  140   CONTINUE
      ENDIF

C  IF USING COMPUTED BREACH AND/OR CULVERT FLOWS, COMMENT OFF THE 
C    LINES BELOW WHICH USE THE MEASURED (READ IN) FLOW VALUES 
C      QSC(1)=MBS(I)
C      QNC(1)=MBN(I)
c      QSC(2)=MECS(I)+MWCS(I)  !  DGT commented this out
c      QNC(2)=MECN(I)+MWCN(I)  !  DGT commented this out

C  USE FILL FLOW MATRIX TO DETERMINE FILL FLOW BASED ON 1973 CONDITIONS
      CALL INTER3(MATRIX,PS,DP,LEN,HD,Q1F)
      FBE=FEBE+I*((FBBE-FEBE)/2304)
      Y2F=LEN-FBE-HD*PS/DP
      IF(Y2F.LE.0.)Y2F=0.0
      Q2F=73.40086*(DP*Y2F**2)
      IF(Q2F.GT.4300.0)Q2F=84.40083*(DP*Y2F**2)-516.5435
      IF(Q1F.LE.0.)Q1F=0.0
      IF(Q2F.LE.0.)Q2F=0.0
      IF(DP.LE..05.AND.HD.GT.0.60)Q2F=0.0

C  FILL FLOW REDUCTION FACTOR EQS 
      FEI=FEEI+I*((FBEI-FEEI)/2304)
      FNP=FENP+I*((FBNP-FENP)/2304)
      FOP=FEOP+I*((FBOP-FEOP)/2304)
c   DGT made this an input parameter
      FOP=FOPIN(IN)
      FSE=LES
      FNE=Y2F+FBE
      IF(FSE.GE.FEI)THEN
         FCFS=(((FSE-DMAX1(FEI,FNE))*FNP)+
     -    ((FEI-DMAX1(0.00D0,FNE))*FOP))/(FSE-DMAX1(FBE,FNE))
      ELSE
         FCFS=FOP
      ENDIF
      IF(FNE.GE.FEI)THEN
         FCFN=((((FNE-FEI)*FNP)+((FEI-FBE)*FOP))/(FNE-FBE))
      ELSE
         FCFN=FOP
      ENDIF

C  ADJUST FILL FLOWS COMPUTED WITH 1973 CONDITIONS TO REFLECT 
C    1987-98 CONDITIONS JUST CALCULATED
      FS=Q1F*FCFS
      FN=Q2F*FCFN

C  COMPUTE TOTAL FLOW THRU THE CAUSEWAY IN EACH DIRECTION IN ACFT/TS
      QS=(QSC(1)+QSC(2)+FS)*TS*CAC
      QN=(QNC(1)+QNC(2)+FN)*TS*CAC
      QSMSUM=QSMSUM+QS  !  Summing monthly flows
      QNMSUM=QNMSUM+QN
      

C      WRITE(16,152)
C 152   FORMAT('LES LEN QS QN QSC FN FS HD')     
C 152   FORMAT(f9.3,1x,f9.3,1x,f4.2,1x,f13.5,1x,f13.5,1x,f13.6,1x,f13.6)

C  COMMENT OFF THE FOLLOWING 4 LINES IF YOU WANT TO USE ESTIMATED
C     EVAPORATION COMPUTED IN THE WATER BALANCE PROGRAM
      SCFS=1.0-0.00778*(CS/PS)
      SCFN=1.0-0.00778*(CN/PN)
      QES(I)=XES(I)*AS*SCFS
      QEN(I)=XEN(I)*AN*SCFN

C  COMPUTE NEW VOLUMES, ELEVATIONS AND AREAS  
c      VS=VS-QS+QN+QIS(I)-QES(I)
c      VN=VN+QS-QN+QIN(I)-QEN(I)-QWP(I)
c   DGT revised these as below
      QIS(I)=(AQISA(IN)*AS+AQISB(IN)+AQISC(IN)-PONDWS(IN)+
     -  PRFS(IN))/float(TSPM)
      QIN(I)=(AQINA(IN)*AN+AQINB(IN)-PONDWN(IN)+
     -  PRFN(IN))/float(TSPM)
     
c  These volume equations are in acre-ft    
      VSnew=VS-QS+QN+QIS(I)-QES(I)
      VNnew=VN+QS-QN+QIN(I)-QEN(I)-QWP(I)
      

c  DGT replaced the following time step specific code below
!      IF(I.LT.1344)THEN
!            CALL RINTER(LES,VS,SOUTHA,NBATH)  ! Returns LES given VS input
!            CALL INTERP(LES,AS,SOUTHA,NBATH)  ! Returns AS given LES as input
!         ELSE
!            CALL RINTER(LES,VS,SOUTHB,NBATH)
!            CALL INTERP(LES,AS,SOUTHB,NBATH)
!         ENDIF   
c      IF(USEMC(IN) .eq. 1)THEN
         CALL RINTER(LESnew,VSnew,SOUTH(1,1,SBATHSEL(IN)),NBATH)  ! Returns LESnew given VS input
         CALL INTERP(LESnew,ASnew,SOUTH(1,1,SBATHSEL(IN)),NBATH)  ! Returns AS given LESnew as input
c      ELSE
c         CALL RINTER(LESnew,VS,SOUTH(1,1,2),NBATH)
c         CALL INTERP(LESnew,AS,SOUTH(1,1,2),NBATH)
c      ENDIF   
      CALL RINTER(LENnew,VNnew,NORTH(1,1,NBATHSEL(IN)),NBATH)   
      CALL INTERP(LENnew,ANnew,NORTH(1,1,NBATHSEL(IN)),NBATH)
c    Check that LENnew is not greater than LMAX.  If it is reduce volume and calculate reqd pumping
      if(LENnew .gt. LMAX)then
         vntemp=VNnew
         LENnew=LMAX
         Call LEV2AV(LENnew,ANnew,VNnew,NORTH(1,1,NBATHSEL(IN)),NBATH)
         VDIF=VNtemp-VNnew
      else
        VDIF=0.
      endif  
      VDIFsum=VDIFsum+VDIF  
      

c  DGT keeping track of mass balance quantities for monthly time step
c   This is a bit imprecise because we neglect changes in AN over a month
c   and use the values that have been updated after 1 time step
      PSvol=PSvol+AQISA(IN)*AS/float(TSPM)
      PNvol=PNvol+AQINA(IN)*AN/float(TSPM)
      ESvol=ESvol+QES(I)
      ENvol=ENvol+QEN(I)

C DGT moved the block below that writes output up to here.  At this point
C  all fluxes have been computed.  It is logical to write the fluxes then update the levels      
C*******************  WRITE OUTPUT TO FILES  ************************ 

C  WRITE TO MAIN OUTPUT FILE FOR AT FIRST OF MONTH
      IF(I.EQ.1)WRITE(16,150)I,YEAR,MONTH,HD,LES+4000.,LEN+4000.,
     -    DP,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9,
     -    QSC(1),QNC(1),QSC(2),QNC(2),FS,FN,QES(I)/1.9,
     -    QEN(I)/1.9,KLS/1E9,KLN/1E9,ClLS/1E9,ClLN/1E9,MgLS/1E9,
     -    MgLN/1E9,NaLS/1E9,NaLN/1E9

      IF(DAY.EQ.31)THEN  !  Last day of month so write month totals
          QGSvol=AQISB(IN)+AQISC(IN)
          QGNvol=AQINB(IN)
          WSvol=PONDWS(IN)-PRFS(IN)
          WNvol=PONDWN(IN)-PRFN(IN)+QWP(I)*float(TSPM)
        WRITE(16,150)I,YEAR,MONTH,LES1+4000.,LEN1+4000.,
     -    LS1/1E9,LN1/1E9,CLNPPT1/1E9,
     -    VDIFsum,CS*10,CN*10,QSMSUM,QNMSUM,
     -    PSVol,PNVol,QGSvol,QGNvol,WSVol,WNVol,ESVol,ENVol,AN1,AS1,
     -    VN1,VS1
  150 FORMAT(I6,1x,I4,'-',I2.2,'-1',2F9.2,3F8.4,
     - 17G13.5)
C 150  FORMAT(I6,1x,I4,'-',I2.2,'-1',F7.2,2F9.2,3F7.3,3F8.4,
C     - 8(1x,F8.0),8F8.4,17G13.5)
        QSMSUM=0
        QNMSUM=0
        VDIFsum=0
        PSvol=0
        PNvol=0
        ESvol=0
        ENvol=0     
      END IF
      
      WRITE(17,151)I,YEAR,MONTH,DAY,HD,LES+4000.,LEN+4000.,
     -    DP,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9,
     -    QSC(1),QNC(1),QSC(2),QNC(2),FS,FN,QES(I)/1.9,QEN(I)/1.9,
     -    KLS/1E9,KLN/1E9,ClLS/1E9,ClLN/1E9,MgLS/1E9,MgLN/1E9,
     -    NaLS/1E9,NaLN/1E9,VDIF,CS*10,CN*10,QS,QN
  151 FORMAT(I6,1x,I4,'-',I2.2,'-',I2.2,F7.2,2F9.2,3F7.3,3F8.4,
     - 8(1x,F8.0),8F8.4,5G13.5)

C  WRITE TO SCREEN AND OUTPUT FILES FOR TIMESTEP
c      WRITE(*,80)I,MONTH,DAY,YEAR,HD,LES+4000.,LEN+4000.,
c     -  DP,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9,
c     -  QSC(1),QNC(1),QSC(2),QNC(2),FS,FN
c      WRITE(17,80)I,MONTH,DAY,YEAR,HD,LES+4000.,LEN+4000.,
c     -  DP,PS,PN,LS/1E9,LN/1E9,CLNPPT/1E9,
c     -  QSC(1),QNC(1),QSC(2),QNC(2),FS,FN,VDIF
c      WRITE(18,190)I,MONTH,DAY,YEAR,FS,FN,PS,PN,CS,CN,VN,
c     -  QEN(I),LN,CLNPPT,QSC(1),QNC(1),QSC(2),QNC(2)
c  190 FORMAT(I6,1x,2(I2,'/'),I4,2F8.2,2F8.4,2F7.0,F12.0,
c     -  F7.0,2F12.0,4F7.0)     
     
      LES=LESnew
      LEN=LENnew
      AN=Annew
      VN=VNnew
      AS=ASnew
      VS=VSnew
      
      HD=LES-LEN
      IF(HD.LE.0.08)HD=0.08

C  CALCULATE NEW ION LOAD VALUES
      KLS=KLS-(QS*KCS)+(QN*KCN)
      KLN=KLN+(QS*KCS)-(QN*KCN)-KLWP(I)
      ClLS=ClLS-(QS*ClCS)+(QN*ClCN)
      ClLN=ClLN+(QS*ClCS)-(QN*ClCN)-ClLWP(I)
      MgLS=MgLS-(QS*MgCS)+(QN*MgCN)
      MgLN=MgLN+(QS*MgCS)-(QN*MgCN)-MgLWP(I)
      NaLS=NaLS-(QS*NaCS)+(QN*NaCN)
      NaLN=NaLN+(QS*NaCS)-(QN*NaCN)-NaLWP(I)
      
C  CALCULATE NEW SALT LOAD VALUES in tons
      LS= LS+(QN*LN/VN-QS*LS/VS)+LRETS(IN)/float(TSPM)
     - - PONDWS(IN)/float(TSPM)*LS/VS  ! DGT added pond withdrawal
      LN= LN+(QS*LS/VS-QN*LN/VN)-LWP(I)+LRETN(IN)/float(TSPM)
     - - PONDWN(IN)/float(TSPM)*LN/VN  ! DGT added pond withdrawal
      FCN=LN/VN
      LNPPT=0.0
      RESOLN=0.0
      IF (FCN.GT.483.)THEN
         LNPPT=LN-483.*VN
         CLNPPT=LNPPT+CLNPPT
         LN=LN-LNPPT
      ELSE
         RESOLN=.01*(483.*VN-LN)
         IF(RESOLN.GT.CLNPPT)RESOLN=CLNPPT
         CLNPPT=CLNPPT-RESOLN
         LN=LN+RESOLN
      ENDIF
      IF(CLNPPT.LT.0.)CLNPPT=0.

      ClLN=ClLN-(.607*LNPPT)+(.607*RESOLN)
      NaLN=NaLN-(.393*LNPPT)+(.393*RESOLN)

C  INCREASE DATE COUNTERS IN THE LOOP
c      YEAR=INT(I*TS/365.+1.)  !  DGT these are now obtained from input file
c      MONTH=INT(((I*TS/365.+1.)-YEAR)*12.+1.)
      DAY=DAY+2  
      IF(DAY.EQ.33)THEN
        DAY=1
        LES1=LES
        LEN1=LEN
        LS1=LS
        LN1=LN
        CLNPPT1=CLNPPT
        AN1=AN
        AS1=AS
        VN1=VN
        VS1=VS
c        MONTH=MONTH+1
      ENDIF
c      IF(MONTH.EQ.13)THEN
c        MONTH=1
c        YEAR=YEAR+1
c      ENDIF
c      YEAR=YEAR+YEARIN(1)-1

C  DGT Block of code to write output used to be here.  DGT moved up

C*****************  END MAIN LOOP AND END PROGRAM  ******************

  200 CONTINUE
c      ENDFILE (UNIT=13)  ! DGT Avoid touching and changing date on these input files
c      ENDFILE (UNIT=14)
c      ENDFILE (UNIT=15)
      ENDFILE (UNIT=16)
      ENDFILE (UNIT=17)
c      ENDFILE (UNIT=18)
c      CLOSE (UNIT=13)  ! DGT these were closed after reading
c      CLOSE (UNIT=14)
      CLOSE (UNIT=15)
      CLOSE (UNIT=16)
      CLOSE (UNIT=17)
c      CLOSE (UNIT=18)
      stop
 1000 PRINT *,' Empty or missing input file'  
      END

